package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10074WineResultBean;
import cn.net.cpzslibs.prot.handset.bean.Prot10074WineSendBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10074WineDaBao extends ProtBase {
	private final short iTaskCode10074 = 10074;
	private Gson gson;
	private Prot10074WineResultBean resMsgBean;
	
	public Prot10074WineDaBao() {
		gson = new Gson();

	}
	public Prot10074WineResultBean getResMsgBean() {
		return resMsgBean;
	}
	public void setResMsgBean(Prot10074WineResultBean resMsgBean) {
		this.resMsgBean = resMsgBean;
	}



	public void dealDaBao(SocketCreate create,
                          Prot10074WineSendBean labelBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), labelBean);
	}

	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10074WineSendBean labelBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10074, "开始请求协议");
				sendProt(dos, labelBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10074WineSendBean labelBean)
			throws IOException {
		
		//System.out.println("labelBean-->"+labelBean);
		
		String bodyContent = gson.toJson(labelBean).toString();
		
		System.out.println("转化为json之后的内容"+bodyContent);
		
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10074, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		// sendCheckCode(dos);
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10074, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10074, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resMsgBean = gson.fromJson(jsonData, Prot10074WineResultBean.class);
		}
		recCheckCode(dis);
	}



}
